package com.vendor.burn.ui;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.util.StringTokenizer;
import org.eclipse.swt.dnd.Clipboard;
import org.eclipse.swt.dnd.RTFTransfer;
import org.eclipse.swt.dnd.TextTransfer;
import org.eclipse.swt.dnd.Transfer;
import org.eclipse.swt.dnd.TransferData;
import org.eclipse.swt.events.KeyListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Layout;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Widget;

public class MacAddressEditor extends Composite {
  static final char CHAR_0 = '0';
  
  static final char CHAR_9 = '9';
  
  static final String STR_00 = "00";
  
  static final String STR_0 = "0";
  
  static final String separator = ":";
  
  private Color defaultBackground;
  
  private Text digitalText0;
  
  private Text digitalText1;
  
  private Text digitalText2;
  
  private Text digitalText3;
  
  private Text digitalText4;
  
  private Text digitalText5;
  
  public MacAddressEditor(Composite parent, int style) {
    super(parent, style | 0x800);
    createContent(this);
    setBackground(getColor(1));
    GridLayout layout = new GridLayout();
    layout.numColumns = 13;
    layout.marginBottom = 0;
    layout.marginHeight = 0;
    layout.marginLeft = 0;
    layout.marginRight = 0;
    layout.marginTop = 0;
    layout.marginWidth = 0;
    _setLayout(layout);
    setTabList(new Control[] { (Control)this.digitalText0, (Control)this.digitalText1, (Control)this.digitalText2, (Control)this.digitalText3, (Control)this.digitalText4, (Control)this.digitalText5 });
  }
  
  private void _setLayout(GridLayout layout) {
    setLayout((Layout)layout);
  }
  
  public String getDisplayText() {
    StringBuilder sb = new StringBuilder();
    sb.append(this.digitalText0.getText()).append(":")
      .append(this.digitalText1.getText()).append(":")
      .append(this.digitalText2.getText()).append(":")
      .append(this.digitalText3.getText()).append(":")
      .append(this.digitalText4.getText()).append(":")
      .append(this.digitalText5.getText());
    return sb.toString();
  }
  
  private void createContent(Composite parent) {
    this.digitalText0 = createText(parent, 0);
    this.digitalText0.setLayoutData(createLayoutData());
    createDotLabel(parent);
    this.digitalText1 = createText(parent, 1);
    this.digitalText1.setLayoutData(createLayoutData());
    createDotLabel(parent);
    this.digitalText2 = createText(parent, 2);
    this.digitalText2.setLayoutData(createLayoutData());
    createDotLabel(parent);
    this.digitalText3 = createText(parent, 3);
    this.digitalText3.setLayoutData(createLayoutData());
    createDotLabel(parent);
    this.digitalText4 = createText(parent, 0);
    this.digitalText4.setLayoutData(createLayoutData());
    createDotLabel(parent);
    this.digitalText5 = createText(parent, 1);
    this.digitalText5.setLayoutData(createLayoutData());
  }
  
  private Label createDotLabel(Composite parent) {
    Label label = new Label(parent, 0);
    if (this.defaultBackground == null)
      this.defaultBackground = label.getBackground(); 
    label.setBackground(getColor(1));
    label.setText(":");
    return label;
  }
  
  private GridData createLayoutData() {
    GridData layoutData = new GridData(768);
    layoutData.minimumWidth = 25;
    return layoutData;
  }
  
  private Text createText(Composite parent, int index) {
    Text text = new Text(parent, 16777216);
    text.setData(Integer.valueOf(index));
    text.setTextLimit(2);
    text.addListener(25, (Listener)new VerifyListener());
    text.addListener(15, (Listener)new Object(this, text));
    text.addListener(24, (Listener)new Object(this));
    text.addListener(1, (Listener)new Object(this, index));
    text.addKeyListener((KeyListener)new Object(this));
    return text;
  }
  
  public void pasteKeyPressed() {
    Clipboard clipboard = new Clipboard(Display.getDefault());
    TransferData[] transferDatas = clipboard.getAvailableTypes();
    for (int i = 0; i < transferDatas.length; i++) {
      if (RTFTransfer.getInstance().isSupportedType(transferDatas[i])) {
        System.out.println("Data is available in RTF format");
        break;
      } 
    } 
    String plainText = (String)clipboard.getContents(
        (Transfer)TextTransfer.getInstance());
    clipboard.dispose();
    if (plainText == null)
      return; 
    String[] split = plainText.split("\\:");
    int length = split.length;
    if (length != 6)
      return; 
    this.digitalText0.setText(split[0]);
    this.digitalText1.setText(split[1]);
    this.digitalText2.setText(split[2]);
    this.digitalText3.setText(split[3]);
    this.digitalText4.setText(split[4]);
    this.digitalText5.setText(split[5]);
    this.digitalText0.setFocus();
  }
  
  public void copyKeyPressed() {
    StringBuilder sb = new StringBuilder();
    sb.append(this.digitalText0.getText()).append(":");
    sb.append(this.digitalText1.getText()).append(":");
    sb.append(this.digitalText2.getText()).append(":");
    sb.append(this.digitalText3.getText()).append(":");
    sb.append(this.digitalText4.getText()).append(":");
    sb.append(this.digitalText5.getText());
    Clipboard clipboard = new Clipboard(Display.getDefault());
    String plainText = sb.toString();
    String rtfText = "{\\rtf1\\b Hello World}";
    TextTransfer textTransfer = TextTransfer.getInstance();
    RTFTransfer rftTransfer = RTFTransfer.getInstance();
    clipboard.setContents((Object[])new String[] { plainText, rtfText }, new Transfer[] { (Transfer)textTransfer, (Transfer)rftTransfer });
    clipboard.dispose();
  }
  
  private void dispatchEvent() {
    Event event = new Event();
    event.widget = (Widget)this;
    event.text = getDisplayText();
    notifyListeners(24, event);
  }
  
  private Color getColor(int colorID) {
    Display default1 = Display.getDefault();
    if (default1 == null)
      default1 = new Display(); 
    return default1.getSystemColor(colorID);
  }
  
  public void setText(String newMacAddress) {
    if (newMacAddress != null && !"".equals(newMacAddress)) {
      StringTokenizer strToken = new StringTokenizer(newMacAddress, ":");
      String[] strIPAddress = new String[strToken.countTokens()];
      if (strToken.countTokens() != 6)
        return; 
      int k = 0;
      while (strToken.hasMoreTokens()) {
        strIPAddress[k] = strToken.nextToken();
        k++;
      } 
      this.digitalText0.setText(strIPAddress[0]);
      this.digitalText1.setText(strIPAddress[1]);
      this.digitalText2.setText(strIPAddress[2]);
      this.digitalText3.setText(strIPAddress[3]);
      this.digitalText4.setText(strIPAddress[4]);
      this.digitalText5.setText(strIPAddress[5]);
    } 
  }
  
  public static boolean isHexChar(char c) {
    return ((c >= '0' && c <= '9') || (c >= 'a' && c <= 'f') || (c >= 'A' && c <= 'F'));
  }
  
  public void setEnabled(boolean enabled) {
    this.digitalText0.setEnabled(enabled);
    this.digitalText1.setEnabled(enabled);
    this.digitalText2.setEnabled(enabled);
    this.digitalText3.setEnabled(enabled);
    this.digitalText4.setEnabled(enabled);
    this.digitalText5.setEnabled(enabled);
  }
}
